<?php
// +--------------------------------------------------------------------------+
// | PayPal Plugin - geeklog CMS                                              |
// +--------------------------------------------------------------------------+
// | confirmation.php                                                         |
// |                                                                          |
// | Check page for users of the paypal plugin                                |
// |                                                                          |
// | By default displays available products along with links to purchase      |
// | history and detailed product views                                       |
// +--------------------------------------------------------------------------+
// |                                                                          |
// | Copyright (C) 2011 by the following authors:                             |
// |                                                                          |
// | Authors: Ben     -    ben AT geeklog DOT fr                              |
// +--------------------------------------------------------------------------+
// |                                                                          |
// | This program is free software; you can redistribute it and/or            |
// | modify it under the terms of the GNU General Public License              |
// | as published by the Free Software Foundation; either version 2           |
// | of the License, or (at your option) any later version.                   |
// |                                                                          |
// | This program is distributed in the hope that it will be useful,          |
// | but WITHOUT ANY WARRANTY; without even the implied warranty of           |
// | MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the            |
// | GNU General Public License for more details.                             |
// |                                                                          |
// | You should have received a copy of the GNU General Public License        |
// | along with this program; if not, write to the Free Software Foundation,  |
// | Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.          |
// |                                                                          |
// +--------------------------------------------------------------------------+

/**
 * require core geeklog code
 */
require_once '../lib-common.php';

// START SESSION
session_start();
// INITIALIZE JCART AFTER SESSION START
$cart =& $_SESSION['jcart']; 

// take user back to the homepage if the plugin is not active
if (! in_array('paypal', $_PLUGINS) || COM_isAnonUser() || ($cart->itemcount) < 1) {
    echo COM_refresh($_CONF['site_url'] . '/index.php');
    exit;
}

/* Ensure sufficient privs to read this page */
paypal_access_check('paypal.user');

$vars = array('msg' => 'text',
              'shipping' => 'text'
              );
paypal_filterVars($vars, $_REQUEST);

/* valid price, access and active product only */
$items = array();
$i = 1;
$quantities = array();
$valid_prices = true;
foreach ($cart->get_contents() as $item) {
    $realid = PAYPAL_realId($item['id']);
	$item_id	= $realid[0];
	$items[$i] = $item['id'];
	$namesfromcart[$i] = $item['name'];
	$quantities[$i] = $item['qty'];
	$item_price[$i]	= $item['price'];
	$A = DB_fetchArray(DB_query("SELECT * FROM {$_TABLES['paypal_products']} WHERE id = '{$item_id}' LIMIT 1"));
	if ($item_price[$i] <> PAYPAL_productPrice($A) || !SEC_hasAccess2($A) || $A['active'] != '1') $valid_prices = false;
	$i++;
}
if ($valid_prices !== true) {
	echo COM_refresh($_CONF['site_url'] . '/index.php');
	exit;
}

/**
 * Add a record of the purchase to the DB
 *
 * @param array $products Product Id(s) of Product(s) purchased
 * @param array $quantity Quantity of products purchases
 * @param array $data private IPN variables
 * @todo implemente physical item vs. download, reflected in 'status'
 */
function PAYPAL_handlePurchase($products, $quantity, $data, $names, $prices) {
	global $_TABLES, $_CONF, $_PAY_CONF, $LANG_PAYPAL_1, $LANG_PAYPAL_EMAIL, $_USER, $LANG_confignames;

	// initialize file and names arrays
	$files = array();
	
	//get information for user table
	$sql = "SELECT * FROM {$_TABLES['paypal_users']} WHERE user_id = {$_USER['uid']}";
	$res = DB_query($sql);
	$informations = DB_fetchArray($res);
	
	//txn_id must unique
	$ipn['txn_id'] = COM_makesid();

	// for each item purchased, record purchase in purchase table
	for ($i = 1; $i < count($products) + 1; $i++) {
		if ($_PAY_CONF['debug']) COM_errorLog('Product:' . $products[$i]);
		// grab relevant product data from product table to insert into purchase table.
		$realid = COM_sanitizeID(explode("|", $products[$i]));
		$sql = "SELECT * FROM {$_TABLES['paypal_products']} "
			 . "WHERE id = {$realid[0]}";
		$res = DB_query($sql);
		$A = DB_fetchArray($res);
		if ($_PAY_CONF['debug']) COM_errorLog('Type :' . $A['type']);
		if ($A['product_type'] == 1) {
			$files[] = $_CONF['path'] . '/plugins/paypal/files/' . $A['file'];
		}
		
		//Create our private IPN
		$ipn['mc_gross'] = ($quantity[$i] * $prices[$i]) + $ipn['mc_gross'];
		$ipn['mc_gross_'.$i] = number_format($quantity[$i] * $prices[$i], 2, '.', '');
		$ipn['quantity'.$i] = $quantity[$i];
		$ipn['item_number'.$i] = $products[$i];
		$ipn['item_name'.$i] = $names[$i];

		// Do record anonymous users in purchase table
		if ( $_USER['uid'] > 0 ) {
			// Add the purchase to the paypal purchase table
			//TODO add product name
			$sql = "INSERT INTO {$_TABLES['paypal_purchases']} SET product_id = {$realid[0]}, "
				 . "quantity = {$quantity[$i]}, user_id = {$_USER['uid']}, "
				 . "txn_id = '{$ipn['txn_id']}', "
				 . 'purchase_date = NOW(), status = \'pending\'';

			DB_query($sql);
			if (DB_error()) {
                $error = $LANG_PAYPAL_1['save_fail'];
            } else {
                $error = $LANG_PAYPAL_1['save_success'];
            }
			if ($_PAY_CONF['debug']) {
			    COM_errorLog($sql);
				COM_errorLog($error);
				COM_errorLog('Purchase recorded');
			}
		}

		$namelist[] = $ipn['quantity'.$i] . ' x ' . $ipn['item_name'.$i] . ' | ' .  number_format(($ipn['mc_gross_'.$i]/$ipn['quantity'.$i]), $_CONF['decimal_count'], $_CONF['decimal_separator'], $_CONF['thousand_separator']) . ' ' . $_PAY_CONF['currency'];
	}
	
	//continue to build our ipn data  
	$ipn['txn_type'] = 'check';
	$ipn['order_date'] = date('H:i:s M d, Y T'); //13:49:40 Jul 06, 2011 PDT
	$ipn['mc_gross'] = number_format($ipn['mc_gross'] + $_REQUEST['shipping'], 2, '.', '');
	$ipn['mc_currency'] = $_PAY_CONF['currency'];
	$ipn['custom'] = $_USER['uid'];
	$ipn['address_name'] = $informations['user_name'];
	$ipn['address_street'] = $informations['user_street1'] . ' ' . $informations['user_street2'];
	$ipn['address_zip'] = $informations['user_postal'];
	$ipn['address_city'] = $informations['user_city'];
	$ipn['address_country'] = $informations['user_country'];
	$ipn['payer_email'] = $_USER['email'];
	$ipn['payment_status'] = 'pending';
	$ipn['protection_eligibility'] = '';
	$ipn['address_status'] = '';
	$ipn['payer_id'] = '';
	$ipn['tax'] = '';
	$ipn['payment_date'] = '';
	$ipn['charset'] = '';
	$ipn['first_name'] = '';
	$ipn['mc_fee'] = '';
	$ipn['mc_handling'] = $_REQUEST['shipping'];
	$ipn['address_country_code'] = '';
	$ipn['notify_version'] = '';
	$ipn['payer_status'] = '';
	$ipn['business'] = '';
	$ipn['verify_sign'] = '';
	$ipn['payment_type'] = 'check';
	$ipn['last_name'] = '';
	$ipn['address_state'] = '';
	$ipn['receiver_email'] = '';
	$ipn['payment_fee'] = '';
	$ipn['receiver_id'] = '';
	$ipn['residence_country'] = '';
	$ipn['receipt_id'] = '';
	$ipn['handling_amount'] = '';
	$ipn['transaction_subject'] = '';
	$ipn['payment_gross'] = '';
	$ipn['shipping'] = '';
	$ipn['ipn_track_id'] = '';
	
	PAYPAL_Log(str_replace("'", '&rsquo;', $ipn));
	
	//TODO send email to customer and admin
	// Send the purchaser a confirmation email (if set to do so in config.php)
	if ($_PAY_CONF['purchase_email_user'] ) {
		// setup templates
		$message = COM_newTemplate($_CONF['path'] . 'plugins/paypal/templates/email');
		$message->set_file(array('subject' => 'purchase_by_check_pending_subject.thtml',
								 'message' => 'purchase_by_check_pending_message.thtml' ));
		// site variables
		$message->set_var('site_name', $_CONF['site_name']);
		
		//Email subject
		$message->set_var('order_confirmation', $LANG_PAYPAL_EMAIL['order_confirmation']);

		// list of product names
		for ($i2 = 0; $i2 < ($i-1); $i2++) {
		    $products_list .= '<p align="right">' . $namelist[$i2] . '</p>';
		}
		if ($ipn['mc_handling'] > 0) {
			$products_list .= '<p align="right">' . $LANG_PAYPAL_1['shipping'] . ' ' . number_format($ipn['mc_handling'], $_CONF['decimal_count'], $_CONF['decimal_separator'], $_CONF['thousand_separator']) . ' ' . $_PAY_CONF['currency'] . '</p>';
		}
		$products_list .= '<p align="right">' . $LANG_PAYPAL_1['total_row_label'] . ' ' . number_format($ipn['mc_gross'], $_CONF['decimal_count'], $_CONF['decimal_separator'], $_CONF['thousand_separator']) . ' ' . $_PAY_CONF['currency'] . '</p>';
		$message->set_var('products', $products_list);
		
		//Email messages
		$message->set_var('thank_you', $LANG_PAYPAL_EMAIL['thank_you_order']);
		$message->set_var('thanks', $LANG_PAYPAL_EMAIL['thanks']);

		// paypal details
		$shop_informations = '<p>' . $_PAY_CONF['shop_name'] . '</p><p>' .
                                $_PAY_CONF['shop_street1'] . '<br' . XHTML . '>' .
                                $_PAY_CONF['shop_street2'] . '<br' . XHTML . '>' .
                                $_PAY_CONF['shop_postal'] . ' ' .
                                $_PAY_CONF['shop_city'] . ' ' .
                                $_PAY_CONF['shop_country'] . '</p><hr' . XHTML . '>';
								
        $shop_informations_bottom = '<p>';
		if ($_PAY_CONF['shop_phone1'] != '') $shop_informations_bottom .= '<p>' . $LANG_confignames['paypal']['shop_phone1'] . ' ' . $_PAY_CONF['shop_phone1'] . '<br' . XHTML . '>';
        if ($_PAY_CONF['shop_phone2'] != '') $shop_informations_bottom .= $LANG_confignames['paypal']['shop_phone2'] . ' ' . $_PAY_CONF['shop_phone2'] . '<br' . XHTML . '>';
        if ($_PAY_CONF['shop_fax'] != '') $shop_informations_bottom .= $LANG_confignames['paypal']['shop_fax'] . ' ' . $_PAY_CONF['shop_fax'] . '<br' . XHTML . '>';
		if ($_PAY_CONF['shop_siret'] != '') $shop_informations_bottom .= $LANG_confignames['paypal']['shop_siret'] . ' ' . $_PAY_CONF['shop_siret'] . '<br' . XHTML . '>';
		$shop_informations_bottom .= '</p>';
                                
		$order_date = COM_getUserDateTimeFormat($ipn['order_date']);
		$message->set_var('order_date', $order_date[0]);
		$message->set_var('payer_email', $ipn['payer_email']);
		$message->set_var('address_name', $ipn['address_name']);
		$message->set_var('shop_informations', $shop_informations . $shop_informations_bottom);
		
		$subject = trim($message->parse('output', 'subject'));

		// if specified to mail attachment, do so, otherwise skip attachment

		$message->set_var('send_check', $LANG_PAYPAL_EMAIL['send_check']);
		$text = $message->parse('output', 'message');
		COM_mail($ipn['payer_email'], $subject, $text,
					 $_PAY_CONF['receiverEmailAddr'], true);

		if ($_PAY_CONF['debug']) COM_errorLog('Email was sent');
	}
	//Send email to receiver
	COM_mail($_PAY_CONF['receiverEmailAddr'], $subject, $subject . ' >> ' . $text, '', true);

	$retval .= '<h2>'. $LANG_PAYPAL_1['order_received'] . '</h2>';
	$retval .= '<p>' . $LANG_PAYPAL_EMAIL['thank_you_order'] . '</p>';
	$retval .= '<blockquote><strong>' . $products_list . '</strong></blockquote>';
	$retval .= '<p>&nbsp;</p><p>' . $LANG_PAYPAL_EMAIL['send_check'] . '</p>';
	$retval .= '<blockquote><strong>' . $shop_informations . $shop_informations_bottom . '</strong></blockquote>';
	$retval .= '<p>' . $LANG_PAYPAL_1['confirm_by_email'] . '</p>';
	
	return $retval;
}

/**
 * Log an order
 *
 * Logs the order like an incoming IPN (serialized)
 *
 * @param array $transaction of transaction
 */
function PAYPAL_Log($transaction) {
	global $_SERVER, $_TABLES;

	// Log to database
	$sql = "INSERT INTO {$_TABLES['paypal_ipnlog']} SET ip_addr = '{$_SERVER['REMOTE_ADDR']}', "
		 . "time = NOW(), verified = 1, txn_id = '{$transaction['txn_id']}', "
		 . "ipn_data = '" . serialize($transaction) . "'";
	DB_query($sql);
	if ($_PAY_CONF['debug']) COM_errorLog('IPN recorded');
	return DB_insertId();
}
	

//Main

// EMPTY THE CART
$cart->empty_cart();

$display .= PAYPAL_siteHeader();
$display .= paypal_user_menu();

switch ($_REQUEST['mode']) {
		
	default :

        //Display cart
        $display .= '<div id="cart">
		             <div id="jcart">
                        <ul id="ULcheckoutProcedure">
			                <li>' . $LANG_PAYPAL_1['checkout_step_1'] . '</li>
							<li>' . $LANG_PAYPAL_1['checkout_step_2'] . '</li>
							<li id="LIactiveStep">' . $LANG_PAYPAL_1['checkout_step_3'] . '</li>
						</ul>
					</div></div>';

		$display .= PAYPAL_handlePurchase($items, $quantities, $data, $namesfromcart, $item_price);
		
        $display .= PAYPAL_siteFooter();
}

COM_output($display);

?>